View Issue Details

IDProjectCategoryView StatusLast Update
0003919Far Manager_Commonpublic2021-12-03 17:05
Reporteraflexus Assigned ToDrKnS  
PrioritynormalSeveritymajorReproducibilityalways
Status closedResolutionfixed 
Platformx64OSWindows 
Product Version3.0 
Fixed in Version3.0 
Summary0003919: Вылетает при Alt+Enter
DescriptionВылет при Alt+Enter, Alt+Enter

Версия последняя - build 5923 x86
Steps To ReproduceAlt+Enter, Alt+Enter
Additional Information- Повторяется только на x86 версии
- Вероятно связанно с плагинами, т.к. на чистой установке не наблюдается.
TagsNo tags attached.
Build5926

Activities

aflexus

2021-11-30 18:36

reporter  

DrKnS

2021-11-30 19:39

administrator   bugnote:0017226

aflexus, а где менно вы взяли 5923 x86? farmanager.com / github / ...?
У меня почему-то ваш дамп не совместим с доступными бинарниками.

aflexus

2021-11-30 19:50

reporter   bugnote:0017227

Last edited: 2021-11-30 20:03

View 2 revisions

DrKnS,
https://farmanager.com/nightly/Far30b5923.x86.20211130.7z

Хотя не, прошу прощения, это чуть более ранний билд с тем же номером (и они, похоже, отличаются):
https://farmanager.com/nightly/Far30b5923.x86.20211126.7z

aflexus

2021-11-30 20:20

reporter   bugnote:0017230

И да, для полноты картины, более "новая" версия 5923 х86 от 30.11.2021 так же крашится.
Без загруженных плагинов и с чистым профилем.

DrKnS

2021-11-30 20:50

administrator   bugnote:0017231

Спасибо, получилось.

Выглядит так, как будто хост в момент переключения вернул какой-то мусор.
Что, в принципе, не сильно удивительно, если у вас Windows 10 или вообще Terminal.

Попробуйте понажимать Alt+Enter в этом: http://farmanager.com/farbugs/buffer_info.7z
Если оно покажет GUI сообщение - скопируйте его сюда (по Ctrl+C).

aflexus

2021-12-01 10:50

reporter   bugnote:0017234

---------------------------
CONSOLE_SCREEN_BUFFER_INFO
---------------------------
dwSize = [118, 9001]
dwCursorPosition = [92, 9000]
wAttributes = 7
srWindow = [92, 8971, 90, 9000]
dwMaximumWindowSize = [118, 71]

---------------------------
OK
---------------------------

DrKnS

2021-12-01 11:20

administrator   bugnote:0017235

Спасибо.
srWindow = [92, 8971, 90, 9000] - вот это оно и есть.
Система говорит, что у окна левая граница в позиции 92, а правая в 90, т.е. ширина отрицательная, дальше все ломается.
Починить это достаточно просто, но лучше бы починить и в ОС тоже.

Какие у вас:
- точная версия ОС (ver или winver)
- версия conhost.exe
- размер и название шрифта
- разрешение и масштабирование экрана
?

aflexus

2021-12-01 11:34

reporter   bugnote:0017236

ver - Microsoft Windows [Version 10.0.19044.1348]
conhost.exe - 10.0.19041.1320
шрифт - Consolas 16pt
разрешение - 1920x1200
масштабирование, это я так понимаю, "Scale and layout"? Тогда - 100%

DrKnS

2021-12-01 12:12

administrator   bugnote:0017237

Попробуйте еще повторить на этом:
http://farmanager.com/farbugs/buffer_info.zip

Это примерно то же самое, но без фара.
Если все хорошо - не произойдет ничего.
Если ошибка повторится - выведется текст, подобный тому, что выше.

aflexus

2021-12-01 12:36

reporter   bugnote:0017238

Вроде бы ничего не происходит. Запускал из той же консоли, из которой падает Far.

DrKnS

2021-12-01 12:59

administrator   bugnote:0017239

Спасибо, а так? http://farmanager.com/farbugs/buffer_info2.zip

aflexus

2021-12-01 13:02

reporter   bugnote:0017240

И в этом случае без вылетов и сообщений.

DrKnS

2021-12-01 13:09

administrator   bugnote:0017241

Ясно, спасибо. Тогда попробуем зарепортить им то, что есть.

Тот фар, который сообщение показывает, после этого хотя бы не падает?

aflexus

2021-12-01 14:23

reporter   bugnote:0017242

Бесконечно показывает сообщение, но не крашится.

DrKnS

2021-12-01 15:47

administrator   bugnote:0017243

Ок, и на, всякий случай, повторяется ли с последним хостом? А то вдруг уже исправили.

Проверить можно так:

windows store - search - terminal preview - install
Потом перейти в C:\Program Files\WindowsApps\Microsoft.WindowsTerminalPreview_1.12.2931.0_x64__8wekyb3d8bbwe (или ей подобную) папку, скопировать куда-то в другое место OpenConsole.exe и запустить. Откроется cmd, в нем можно запустить far как обычно.

aflexus

2021-12-01 17:43

reporter   bugnote:0017245

Скачал, установил. Непонятно, исправлено или нет, т.к. при каждом запуске окно смещается пикселей на 10-15 вверх и влево, оставляя справа и внизу от консоли полоску рабочего стола.

Я так понимаю, что этот Package позиционируется как замена стандартной консоли? А что с консолью обычной? Там то обновления будут не скоро.

DrKnS

2021-12-01 20:06

administrator   bugnote:0017246

при каждом запуске окно смещается пикселей на 10-15 вверх и влево
Возможно, там уже внесли новые баги. Проверьте, что хотя бы Alt+Enter соответствует ожиданиям.

этот Package позиционируется как замена стандартной консоли?
Не совсем.
openconsole.exe в этом пакете - это переименованный conhost.exe, собранный из более свежего кода, с исправлениями и фичами. Когда-нибудь он дойдет и через обычные каналы обновления, но, чтобы не ждать, проверять можно и так.

DrKnS

2021-12-02 01:41

administrator   bugnote:0017247

5924

aflexus

2021-12-02 07:16

reporter   bugnote:0017250

Last edited: 2021-12-02 07:27

View 2 revisions

Проверьте, что хотя бы Alt+Enter соответствует ожиданиям.

DrKnS
Да, проверил - в новой консоли версия 5923 не падает. Правда, решение проблемы странное, имхо. Как я написал выше, просто смещают ее влево-вверх на 10-15 пикселей.

Кстати, x64 имеет те же проблемы в этой позиции консоли.

К сожалению, версия 5925 так же падает. Только уже без крашдампа...

DrKnS

2021-12-02 10:33

administrator   bugnote:0017251

К сожалению, версия 5925 так же падает. Только уже без крашдампа...
Видимо, это испорченное состояние возвращается не однократно, а постоянно, и костыли надо расставлять много где, и вообще не факт, что поможет.
Надо понять, почему оно вообще случается.

Как я написал выше, просто смещают ее влево-вверх на 10-15 пикселей.
Что интересно, у меня и на Alt+Enter не падает, и описанного эффекта нет.

Может это у вас что-то локальное? Повторяется ли на другой машине, или на этой, но под другим пользователем?

aflexus

2021-12-02 11:29

reporter   bugnote:0017252

Надо понять, почему оно вообще случается.

DrKnS
Вероятно, случается тогда, когда значение позиции левого угла консоли слегка превышает какой-то предел, при этом правый угол начинает выходить за край экрана. Может деление на 0 где-то?

Т.е. к примеру:
left position = 950;
left position = 952;
left position = 953;
... и т.д. все хорошо

Но при:
left position = 951;
вылет.

Вероятно, то же самое должно быть и по Y.

DrKnS

2021-12-02 12:18

administrator   bugnote:0017253

Да, это оно.

Ключевые моменты:
Font = Consolas 16
Width = 118
WindowPosition.Left = 951
[x] Wrap text output on resize (!)

С таким сетапом у меня повторяется, в том числе и с минимальным примером без фара, в том числе с cmd.exe.

В OpenConsole, действительно, не повторяется и окно немного смещается. Не удивлюсь, если это и есть "исправление".

Кстати, если после этого открыть свойства окна, то там можно наблюдать прекрасное, см. картинку.

Я пока не уверен, что с этим делать.
Получается, что в любой момент у хоста может поехать крыша и API начнет возвращать отрицательную ширину окна.
Наверное, это можно исправить, установив позицию окна вручную.
Но мы не знаем, какую ширину устанавливать.
Можно попробовать угадать, взяв ширину буфера (118 в вашем случае) и сохранив левую позицию (951 в вашем случае).
Я попробую, но не факт, что из этого что-то получится.

Как вариант, можно выключить Wrap text output on resize. В контексте фара от нее все равно один вред.
image.png (19,288 bytes)   
image.png (19,288 bytes)   

DrKnS

2021-12-02 18:23

administrator   bugnote:0017258

5926

aflexus

2021-12-03 07:23

reporter   bugnote:0017259

Да, в 5926 повторить вылет не получается.

Правда обнаружил новый баг, похоже связан с той же консолью, и дабы не плодить сущности, отпишу здесь:
Если отключить чекбокс "Wrap text output on resze", последовательные Alt+Enter каждый раз будут уменьшать высоту консоли на единицу. Это поведение присутствует во всех билдах с 5923 и до последнего.

DrKnS

2021-12-03 09:36

administrator   bugnote:0017260

Да, я в курсе, это тоже баг хоста.

aflexus

2021-12-03 13:47

reporter   bugnote:0017261

Тогда, в принципе, этот баг можно считать закрытым.

Issue History

Date Modified Username Field Change
2021-11-30 18:36 aflexus New Issue
2021-11-30 18:36 aflexus File Added: Far.2021.11.30_18.32.40.501_3724.7z
2021-11-30 19:39 DrKnS Note Added: 0017226
2021-11-30 19:50 aflexus Note Added: 0017227
2021-11-30 20:03 aflexus Note Edited: 0017227 View Revisions
2021-11-30 20:20 aflexus Note Added: 0017230
2021-11-30 20:20 aflexus File Added: Far.2021.11.30_20.12.49.293_1436.7z
2021-11-30 20:50 DrKnS Note Added: 0017231
2021-12-01 10:50 aflexus Note Added: 0017234
2021-12-01 11:20 DrKnS Note Added: 0017235
2021-12-01 11:34 aflexus Note Added: 0017236
2021-12-01 12:12 DrKnS Note Added: 0017237
2021-12-01 12:36 aflexus Note Added: 0017238
2021-12-01 12:59 DrKnS Note Added: 0017239
2021-12-01 13:02 aflexus Note Added: 0017240
2021-12-01 13:09 DrKnS Note Added: 0017241
2021-12-01 14:23 aflexus Note Added: 0017242
2021-12-01 15:47 DrKnS Note Added: 0017243
2021-12-01 17:43 aflexus Note Added: 0017245
2021-12-01 20:06 DrKnS Note Added: 0017246
2021-12-02 01:41 DrKnS Assigned To => DrKnS
2021-12-02 01:41 DrKnS Status new => feedback
2021-12-02 01:41 DrKnS Note Added: 0017247
2021-12-02 07:16 aflexus Note Added: 0017250
2021-12-02 07:16 aflexus Status feedback => assigned
2021-12-02 07:27 aflexus Note Edited: 0017250 View Revisions
2021-12-02 10:33 DrKnS Note Added: 0017251
2021-12-02 11:29 aflexus Note Added: 0017252
2021-12-02 11:29 aflexus File Added: Annotation 2021-12-02 131540.png
2021-12-02 12:18 DrKnS Note Added: 0017253
2021-12-02 12:18 DrKnS File Added: image.png
2021-12-02 18:23 DrKnS Status assigned => feedback
2021-12-02 18:23 DrKnS Note Added: 0017258
2021-12-03 07:23 aflexus Note Added: 0017259
2021-12-03 07:23 aflexus Status feedback => assigned
2021-12-03 09:36 DrKnS Note Added: 0017260
2021-12-03 13:47 aflexus Note Added: 0017261
2021-12-03 17:05 DrKnS Status assigned => closed
2021-12-03 17:05 DrKnS Resolution open => fixed
2021-12-03 17:05 DrKnS Fixed in Version => 3.0
2021-12-03 17:05 DrKnS Build => 5926